
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

use work.const.all;

entity ram is
port(
	clk, wr: in std_logic;
	addr: in ram_adr_type;
	idata: in dat_type;
	odata: out dat_type
);
end entity ram;

architecture rtl of ram is
	type ram_type is array (0 to 2**ram_w-1) of dat_type;
	signal ram: ram_type;
	signal pos: std_logic_vector(ram_w-3 downto 0);
begin
	pos <= addr(ram_w-1 downto 2);
	cells: process(clk, wr, idata)
	begin
		
		if clk = '1' and clk'event and wr = '1' then
			ram(conv_integer(pos)) <= idata;
		end if;
	end process;

	odata <= ram(conv_integer(pos));
end architecture rtl;
