
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_textio.all;
use std.textio.all;

use work.const.all;

entity rom is
	port(
		clk, wr: in std_logic;
		addr: in rom_adr_type;
		idata: in dat_type;
		odata: out dat_type
	);
end entity rom;

architecture rtl of rom is
	type rom_type is array (0 to 2**rom_w-1) of dat_type;
	impure function init_rom
		return rom_type is
		file afile: text open read_mode is "rom.bin";
		variable tmp: rom_type := (others => (others => '0'));
		variable aline: line;
		variable dat: dat_type;
		variable adr: adr_type;
		variable pos: std_logic_vector(rom_w-3 downto 0);
	begin
		L1: loop
			exit when endfile(afile);
			readline(afile, aline);
			hread(aline, adr);
			read(aline, dat);
			pos := adr(rom_w-1 downto 2);
			tmp(conv_integer(pos)) := dat;
		end loop;
		return tmp;
	end init_rom;

	signal rom: rom_type := init_rom;
	signal ipos: std_logic_vector(rom_w-3 downto 0);
begin
	ipos <= addr(rom_w-1 downto 2);
	odata <= rom(conv_integer(ipos));
end architecture rtl;
