
enum {
	HALT,NOP,
	LDB,LDW,LD,STB,STW,ST,
	LDIH,LDIL,LDI,
	ADD,SUB,OR,AND,MOV,IMOV,FMOV,SLL,SRL,XOR,NOT,NEG,ITLB,DTLB,
	JMP,BRN,IRET,BS,
	DATA, EQU, FILL, ORG
};

#define PROG "as"
#define MAXLABELS 100
#define MAXLABEL_SIZ 11
#define MAXCODES 20000

struct label {
	char *s;
	char def;
	unsigned long offset;
};

struct code {
	char op;
	char imm_islabel;
	char relative;
	unsigned line;
	unsigned long imm;
	unsigned char src1, src2, dst;
	unsigned char cond;
};

extern void error_(unsigned linenum, char *fmt, va_list va);
extern void pass1(void);
extern void pass2(void);
extern void die(char *fmt, ...);
extern struct label *lookup(char *s);
